'********************************************************************
'*
'* File:           MemUtils.vbs
'* Created:        February 18, 2002
'* Version:        1.0
'*
'*  Main Function:  Retrieves Memory Counter Information
'*
'*  MemUtils.vbs      [/S <server>] [/G <option>]
'*                         
'*
'* Copyright (C) 2002 Shitworks
'*
'********************************************************************

OPTION EXPLICIT

    'Define constants
    CONST CONST_ERROR                   = 0
    CONST CONST_WSCRIPT                 = 1
    CONST CONST_CSCRIPT                 = 2
    CONST CONST_SHOW_USAGE              = 3
    CONST CONST_PROCEED                 = 4
    CONST CONST_PERCENT_FREE            = "PercentFree"
    CONST CONST_PERCENT_USED            = "PercentUsed"
    CONST CONST_BYTES_FREE              = "BytesFree"
    CONST CONST_BYTES_USED              = "BytesUsed"
    CONST CONST_PAGES_PER_SECOND        = "PagesPerSec"


    'Declare variables
    Dim intOpMode, i
    Dim strServer, strUserName, strPassword, strOption


    'Parse the command line
    intOpMode = intParseCmdLine(strServer     ,  _
                                strUserName   ,  _
                                strPassword   ,  _
                                strOption)


    Select Case intOpMode

        Case CONST_SHOW_USAGE
            Call ShowUsage()

        Case CONST_PROCEED                 
            Call GetValueFor(strServer     , _
                               strUserName    , _
                               strPassword    , _
                               strOption)

        Case CONST_ERROR
            'Do Nothing

        Case Else                    'Default -- should never happen
            Call Wscript.Echo("Error occurred in passing parameters.")

    End Select

'********************************************************************
'* End of Script
'********************************************************************

'********************************************************************
'*
'* Sub GetValueFor()
'*
'* Purpose: Lists the available memory of a machine.
'*
'* Input:   strServer           a machine name
'*          strOutputFile       an output file name
'*          strUserName         the current user's name
'*          strPassword         the current user's password
'*
'* Output:  Results are either printed on screen or saved in strOutputFile.
'*
'********************************************************************
Private Sub GetValueFor(strServer, strUserName, strPassword, strOption)

    ON ERROR RESUME NEXT
    Dim objService, objEnumerator, objInstance
    Dim strQuery
    Dim strMemAvailable, strMemTotal

    'Establish a connection with the server.
    If blnConnect("root\cimv2" , _
                   strUserName , _
                   strPassword , _
                   strServer   , _
                   objService  ) Then
        Call Wscript.Echo("")
        Call Wscript.Echo("Please check the server name, " _
                        & "credentials and WBEM Core.")
        Exit Sub
    End If


    Select Case strOption

      Case CONST_PERCENT_FREE


       Set objEnumerator = objService.InstancesOf("Win32_PerfRawData_PerfOS_Memory")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemAvailable = strMemAvailable + objInstance.AvailableKBytes

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next
 
       Set objEnumerator = objService.InstancesOf("Win32_OperatingSystem")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemTotal = strMemTotal + objInstance.TotalVisibleMemorySize

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next

       Wscript.Echo (Round((strMemAvailable/strMemTotal)*100))



      Case CONST_PERCENT_USED

       Set objEnumerator = objService.InstancesOf("Win32_PerfRawData_PerfOS_Memory")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemAvailable = strMemAvailable + objInstance.AvailableKBytes

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next
 
       Set objEnumerator = objService.InstancesOf("Win32_OperatingSystem")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemTotal = strMemTotal + objInstance.TotalVisibleMemorySize

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next

       Wscript.Echo (100 - (Round((strMemAvailable/strMemTotal)*100)))



      Case CONST_BYTES_FREE

       Set objEnumerator = objService.InstancesOf("Win32_PerfRawData_PerfOS_Memory")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemAvailable = strMemAvailable + objInstance.AvailableKBytes

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next
 
       Set objEnumerator = objService.InstancesOf("Win32_OperatingSystem")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemTotal = strMemTotal + objInstance.TotalVisibleMemorySize

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next

       Wscript.Echo (strMemAvailable)


      Case CONST_BYTES_USED

       Set objEnumerator = objService.InstancesOf("Win32_PerfRawData_PerfOS_Memory")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemAvailable = strMemAvailable + objInstance.AvailableKBytes

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next
 
       Set objEnumerator = objService.InstancesOf("Win32_OperatingSystem")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            strMemTotal = strMemTotal + objInstance.TotalVisibleMemorySize

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next

       Wscript.Echo (strMemTotal - strMemAvailable)


     Case CONST_PAGES_PER_SECOND


       Set objEnumerator = objService.InstancesOf("Win32_PerfRawData_PerfOS_Memory")
       If Err.Number Then
          Wscript.Echo("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred during the query.")
          If Err.Description <> "" Then
              Wscript.Echo("Error description: " & Err.Description & ".")
          End If
          Err.Clear
          Exit Sub
       End If

       For Each objInstance in objEnumerator
           If Not (objInstance is nothing) Then

            Wscript.Echo objInstance.PagesPerSec

           End If
           If Err.Number Then
            Err.Clear
           End If
       Next

      Case Else

      Wscript.Echo -1

    End Select

End Sub

'********************************************************************
'*
'* Function intParseCmdLine()
'*
'* Purpose: Parses the command line.
'* Input:   
'*
'* Output:  strServer         a remote server ("" = local server")
'*          strUserName       the current user's name
'*          strPassword       the current user's password
'*          strOutputFile     an output file name
'*
'********************************************************************
Private Function intParseCmdLine( ByRef strServer,        _
                                  ByRef strUserName,      _
                                  ByRef strPassword,      _
                                  ByRef strOption)

    ON ERROR RESUME NEXT

    Dim strFlag
    Dim intState, intArgIter

    If Wscript.Arguments.Count > 0 Then
        strFlag = Wscript.arguments.Item(0)
    End If

    If IsEmpty(strFlag) Then                'No arguments have been received
        intParseCmdLine = CONST_PROCEED
        Exit Function
    End If

    'Check if the user is asking for help or is just confused
    If (strFlag="help") OR (strFlag="/h") OR (strFlag="\h") OR (strFlag="-h") _
        OR (strFlag = "\?") OR (strFlag = "/?") OR (strFlag = "?") _ 
        OR (strFlag="h") Then
        intParseCmdLine = CONST_SHOW_USAGE
        Exit Function
    End If

    'Retrieve the command line and set appropriate variables
     intArgIter = 0
    Do While intArgIter <= Wscript.arguments.Count - 1
        Select Case Left(LCase(Wscript.arguments.Item(intArgIter)),2)
  
            Case "/s"
                If Not blnGetArg("Server", strServer, intArgIter) Then
                    intParseCmdLine = CONST_ERROR
                    Exit Function
                End If
                intArgIter = intArgIter + 1

            Case "/g"
                If Not blnGetArg("Option", strOption, intArgIter) Then
                    intParseCmdLine = CONST_ERROR
                    Exit Function
                End If
                intArgIter = intArgIter + 1

            Case Else 'We shouldn't get here
                Call Wscript.Echo("Invalid or misplaced parameter: " _
                   & Wscript.arguments.Item(intArgIter) & vbCRLF _
                   & "Please check the input and try again," & vbCRLF _
                   & "or invoke with '/?' for help with the syntax.")
                Wscript.Quit

        End Select

    Loop '** intArgIter <= Wscript.arguments.Count - 1

    If IsEmpty(intParseCmdLine) Then _
        intParseCmdLine = CONST_PROCEED

End Function

'********************************************************************
'*
'* Sub ShowUsage()
'*
'* Purpose: Shows the correct usage to the user.
'*
'* Input:   None
'*
'* Output:  Help messages are displayed on screen.
'*
'********************************************************************
Private Sub ShowUsage()

    Wscript.Echo ""
    Wscript.Echo "Lists memory counters on a machine."
    Wscript.Echo ""
    Wscript.Echo "SYNTAX:"
    Wscript.Echo "  MemUtils.vbs [/S <server>]" _
                &" [/G <option>]"
    Wscript.Echo ""
    Wscript.Echo "PARAMETER SPECIFIERS:"
    Wscript.Echo "   server        A machine name."
    Wscript.Echo "   option        Is one of the following:"
    Wscript.Echo ""
    Wscript.Echo "                 PercentFree"
    Wscript.Echo "                 PercentUsed"
    Wscript.Echo "                 BytesFree"
    Wscript.Echo "                 BytesUsed"
    Wscript.Echo "                 PagesPerSec"
    Wscript.Echo ""
    Wscript.Echo "EXAMPLE:"
    Wscript.Echo "   1.  MemUtils.vbs /S MyMachine2 /G PercentUsed"
    Wscript.Echo "   Lists the percentage of used memory on MyMachine2"


End Sub

'********************************************************************
'* General Routines
'********************************************************************

'********************************************************************
'* 
'*  Function blnGetArg()
'*
'*  Purpose: Helper to intParseCmdLine()
'* 
'*  Usage:
'*
'*     Case "/s" 
'*       blnGetArg ("server name", strServer, intArgIter)
'*
'********************************************************************
Private Function blnGetArg ( ByVal StrVarName,   _
                             ByRef strVar,       _
                             ByRef intArgIter) 

    blnGetArg = False 'failure, changed to True upon successful completion

    If Len(Wscript.Arguments(intArgIter)) > 2 then
        If Mid(Wscript.Arguments(intArgIter),3,1) = ":" then
            If Len(Wscript.Arguments(intArgIter)) > 3 then
                strVar = Right(Wscript.Arguments(intArgIter), _
                         Len(Wscript.Arguments(intArgIter)) - 3)
                blnGetArg = True
                Exit Function
            Else
                intArgIter = intArgIter + 1
                If intArgIter > (Wscript.Arguments.Count - 1) Then
                    Call Wscript.Echo( "Invalid " & StrVarName & ".")
                    Call Wscript.Echo( "Please check the input and try again.")
                    Exit Function
                End If

                strVar = Wscript.Arguments.Item(intArgIter)
                If Err.Number Then
                    Call Wscript.Echo( "Invalid " & StrVarName & ".")
                    Call Wscript.Echo( "Please check the input and try again.")
                    Exit Function
                End If

                If InStr(strVar, "/") Then
                    Call Wscript.Echo( "Invalid " & StrVarName)
                    Call Wscript.Echo( "Please check the input and try again.")
                    Exit Function
                End If

                blnGetArg = True 'success
            End If
        Else
            strVar = Right(Wscript.Arguments(intArgIter), _
                     Len(Wscript.Arguments(intArgIter)) - 2)
            blnGetArg = True 'success
            Exit Function
        End If
    Else
        intArgIter = intArgIter + 1
        If intArgIter > (Wscript.Arguments.Count - 1) Then
            Call Wscript.Echo( "Invalid " & StrVarName & ".")
            Call Wscript.Echo( "Please check the input and try again.")
            Exit Function
        End If

        strVar = Wscript.Arguments.Item(intArgIter)
        If Err.Number Then
            Call Wscript.Echo( "Invalid " & StrVarName & ".")
            Call Wscript.Echo( "Please check the input and try again.")
            Exit Function
        End If

        If InStr(strVar, "/") Then
            Call Wscript.Echo( "Invalid " & StrVarName)
            Call Wscript.Echo( "Please check the input and try again.")
            Exit Function
        End If
        blnGetArg = True 'success
    End If
End Function

'********************************************************************
'*
'* Function blnConnect()
'*
'* Purpose: Connects to machine strServer.
'*
'* Input:   strServer       a machine name
'*          strNameSpace    a namespace
'*          strUserName     name of the current user
'*          strPassword     password of the current user
'*
'* Output:  objService is returned  as a service object.
'*          strServer is set to local host if left unspecified
'*
'********************************************************************
Private Function blnConnect(ByVal strNameSpace, _
                            ByVal strUserName,  _
                            ByVal strPassword,  _
                            ByRef strServer,    _
                            ByRef objService)

    ON ERROR RESUME NEXT

    Dim objLocator, objWshNet

    blnConnect = False     'There is no error.

    'Create Locator object to connect to remote CIM object manager
    Set objLocator = CreateObject("WbemScripting.SWbemLocator")
    If Err.Number then
        Call Wscript.Echo( "Error 0x" & CStr(Hex(Err.Number)) & _
                           " occurred in creating a locator object." )
        If Err.Description <> "" Then
            Call Wscript.Echo( "Error description: " & Err.Description & "." )
        End If
        Err.Clear
        blnConnect = True     'An error occurred
        Exit Function
    End If

    'Connect to the namespace which is either local or remote
    Set objService = objLocator.ConnectServer (strServer, strNameSpace, _
       strUserName, strPassword)
    ObjService.Security_.impersonationlevel = 3
    If Err.Number then
        Call Wscript.Echo( "Error 0x" & CStr(Hex(Err.Number)) & _
                           " occurred in connecting to server " _
           & strServer & ".")
        If Err.Description <> "" Then
            Call Wscript.Echo( "Error description: " & Err.Description & "." )
        End If
        Err.Clear
        blnConnect = True     'An error occurred
    End If

    'Get the current server's name if left unspecified
    If IsEmpty(strServer) Then
        Set objWshNet = CreateObject("Wscript.Network")
    strServer     = objWshNet.ComputerName
    End If

End Function


'********************************************************************
'* 
'* Function blnErrorOccurred()
'*
'* Purpose: Reports error with a string saying what the error occurred in.
'*
'* Input:   strIn		string saying what the error occurred in.
'*
'* Output:  displayed on screen 
'* 
'********************************************************************
Private Function blnErrorOccurred (ByVal strIn)

    If Err.Number Then
        Call Wscript.Echo( "Error 0x" & CStr(Hex(Err.Number)) & ": " & strIn)
        If Err.Description <> "" Then
            Call Wscript.Echo( "Error description: " & Err.Description)
        End If
        Err.Clear
        blnErrorOccurred = True
    Else
        blnErrorOccurred = False
    End If

End Function


'********************************************************************
'*                                                                  *
'*                           End of File                            *
'*                                                                  *
'********************************************************************
